
Listing 1


  `Global Procedure Print Org Chart
  `Sample of 4th Dimension procedure code

  `Procedure generates an outline-style org chart for all people
  `under any one person in the organization.   Key field is Mailname;
  `each person is linked to another (in the same file) via field Manager

  `First, get input from the user
SearchName:=Request("Print org chart for which person?")

  `System OK variable is set to 1 if they pressed OK, 0 if pressed cancel
If (OK=1)

       `Filenames are in square brackets; field names are
       `[Filename]Fieldname
  SEARCH([People];[People]Mailname=SearchName)
  
    `First, see if we found a valid person, with a case statement for
    `all the possible situations:
  Case of 
    : (Records in selection([People])=0)
      BEEP
      ALERT("No person with this mailname")
      
    : (Records in selection([People])>1)
      BEEP
      ALERT("More than one person match this.")
      
    Else 
      
        `We found one person.  Initialize some constants...  
      gCR:=Char(13)
      gTab:=Char(9)
      OrgChart:=""
      
        `and initialize our arrays.  People are pushed onto 
	`and popped off of a stack in memory, which is nothing 
	`but a big array
      ARRAY STRING(35;asOrg;100)
      ARRAY INTEGER(aiLevel;100)
      ARRAY INTEGER(aiPrinted;100)
      
        `Note that local (private) variables are preceded with
	`dollar sign, and arrays are noted with curly brackets {}
      $counter:=1
      $level:=0
      
      asOrg{$counter}:=SearchName
      aiPrinted{$counter}:=0
      aiLevel{$counter}:=$level
      
      Repeat 
        If (aiPrinted{$counter}#1)
          
            `Find all the people who report to the current person          
          SEARCH([People];[Departments]MgrMailname=asOrg{$counter})
          
          If (Records in selection([People])>0)
            
              `Indent this person with as many tabs as they 
	      `are levels deep. Note the plus sign signifies 
	      `string concatenation as well as addition.
              `Note also that characters (gTab) can be multiplied
	      `by a number
            OrgChart:=OrgChart+gCR+(gTab*aiLevel{$counter})+asOrg{$counter}
            aiPrinted{$counter}:=1  `flag it as printed
            $level:=aiLevel{$counter}+1
            
              `We now have a "selection" of records.  Sort it in 
	      `descending order, which doesn't require an index; 
	      `we can sort anything at any time...
            SORT SELECTION([People];[People]Mailname;<)
            
              `And add all those people to our stack
            For ($i;1;Records in selection([People]))
              $counter:=$counter+1
              asOrg{$counter}:=[People]Mailname
              aiLevel{$counter}:=$level
              aiPrinted{$counter}:=0
              NEXT RECORD([People])
            End for 
            
              `If we're here, there are no people reporting to this 
              `person so let's add him to our org chart        
          Else 
            
            OrgChart:=OrgChart+gCR+(gTab*aiLevel{$counter})+asOrg{$counter})
            $counter:=$counter-1
            
          End if 
          
        Else   

               `We've added this one already, so let's go back up the stack
          $counter:=$counter-1
        End if   `if(aiprinted #1)  
        
      Until ($counter=0)
      
        `The variable OrgChart now contains the entire text of our org chart.  
        `Open a file and save it to disk.      
      If (Length(OrgChart)>0)
        $docRefNumb:=Open document("Org Chart")
        SEND PACKET($docRefNumb;OrgChart)
        CLOSE DOCUMENT($docRefNumb)
      End if 
      
        `And, clear our arrays...      
      ARRAY STRING(35;asOrg;0)
      ARRAY INTEGER(aiLevel;0)
      ARRAY INTEGER(aiPrinted;0)
  End case 
End if 
