
Listing 1


;----------------------------------------------------------------
; Check script is the core of our demonstration
; TranInfo is the main procedure of this demonstration. It loads
; and executes the Toolkit procedures required to run the demo.
;----------------------------------------------------------------
Proc TranInfo()
  Readlib Sdir() + "Toolkit" InitWait, ;Loads DoWait
                         SetKeycodes, ;Defines mnemonic keycodes
                         Setpopup, ;Defines Popup arrays
                         EditMenu ;Presents a simple edit menu
  SetKeycodes() ;SetKeycodes defines variables making it easier
                ; to remember ASCII, IBM Extended keycode values
  InitWait(2,"1,2","Cust,Trans")
		;InitWait loads DoWait and its supplementary
                ; procedures. This particular set of
                ; arguments instructs DoWait that:
                ; 1. the highest image number of a table we'll
                ;    be using with DoWait is 2.
                ; 2. the image numbers of the tables we'll be
                ;    using (Cust, Trans) is "1,2".
                ; 3. the tables linked to the image numbers are
                ;    "Cust,Trans"
  Setpopup("acct,reps")    ;initialize popup arrays with tables

  Release Procs InitWait,   ;Release procs we no longer need
  SetKeycodes,Setpopup

  Setswap 30000

  View "Cust"
  View "Trans"
   If RecNo() = 0 ;If the table is empty, Paradox will open up
      Then EditKey ; a new record for us automatically
      PickForm "1"
   Else Pickform "1"
           EditKey
           End PgDn ;Open up a new master record
   Endif DoWait("Welcome to the Main Street Trust Co., Check
     Clearing System on " + StrVal(Today())) ;Invoke
   DoWait
   Clear
   Prompt            ;Restore the Paradox system prompt line

   If Retval = TKDo It!  ;If F2 was pressed to exit DoWait, save
      Then Do It!        ;changes. Otherwise, cancel all changes.
      Else CancelEdit
   Endif

Endproc

;----------------------------------------------------------------
;Main Program
;----------------------------------------------------------------
Play "ChkProcs" ;Define embedded procedures
Play "TransPro" ;Define DoWait procedure assignments and key
		: classes for Trans
Play "CustPro"  ;Define DoWait procedure assignments and key
		: classes for Cust
ClearAll        ;Must Clear workspace
TranInfo()      ;execute core
Release Vars TableName, FormId, BorrowFile
;You probably want to put a menu here
ClearAll

