
Listing 2


;----------------------------------------------------------------
;Script ChkProcs contains all the relevant embedded Procedures
;----------------------------------------------------------------

Proc TransTbl()
;----------------------------------------------------------------
;Table Arrival Procedure for Trans Table
;Simply displays the appropriate prompt.
;----------------------------------------------------------------
Prompt "--------- Editing Check Transaction ----------" ,
       "Press F10 for Options, Leave Cust ID Blank To Exit/NoSave"
Endproc

Proc NewTrans()
;----------------------------------------------------------------
;Record Arrival Procedure for Trans Table
;Simply assigns the record number to the Trans# field in Trans
;and puts the user in the Cust Id field in Trans.
;----------------------------------------------------------------
 MoveTo [Trans#]
 Arrivefield()
 If Isblank([Trans#])
   Then [Trans#] = Recno()
 Endif
 MoveTo [Cust id]
 Arrivefield()
EndProc

Proc Searcher()
;----------------------------------------------------------------
;Field Arrival procedure for Cust Id Field in Trans Table
;Exits if field is blank, otherwise puts user in the Cust Table.
;----------------------------------------------------------------
 If Not IsBlank([])
   Then TkAccept = True
   Moveto [Cust->]
   ArriveTable()        ; Will execute table arrival procedure
 Else Del               ; Delete the appended record
 TKKeytype  =  "X"      ; Exit Key
 Endif
Endproc

Proc ChkAmt()
;-------------------------------------------------------------------
;Field Good Depart procedure for Amount Field in Trans Table
;Checks to see if the customer has enough money in the bank to cover
;the check, clearing or not clearing it accordingly. If not cleared,
;message displays. If Cleared, updates the balance in Cust table.
;Puts user in the Cust_Rep Field in the Trans table either way.
;-------------------------------------------------------------------
 If ([Cust->Balance]  [Amount])>=0
 Then [Cleared] = "Y"
 MoveTo [Cust->Balance]
 NewTable()                            ;not Arrivetable()
 NewField()
 [Balance] = [Balance]  [Trans->Amount]
 MoveTo [Trans->]
 NewTable()
 Else
 [Cleared] = "N"
TkMessage="This Customer has inadequate funds, Please inform Supervisor Before You Leave!"
 Endif
 MoveTo [Cust_Rep]
 Arrivefield()
Endproc

Proc Cslkup()
;----------------------------------------------------------------
;Field Bad Depart Procedure for Cust_Rep Field in Trans Table
;Simply displays message
;----------------------------------------------------------------
 TKMessage =
 "Illegal Value, Please Enter the Correct Value or Press F1 for List"
Endproc

Proc Help1()
;----------------------------------------------------------------
;Field Keystroke Procedure for Cust_Rep Field in Trans Table
;Displays Popup list to choose from and assigns value
;----------------------------------------------------------------
 If TKChar = TKHelp
 Then CtrlBackspace
 Popup(10,24,2,6)
 [] = retval
 TKChar = TKCtrlHome
 Endif
EndProc

Proc CustChk()
;----------------------------------------------------------------
;Table Arrival Procedure for Cust Table
;If there was no linked customer (master record) displays message, changes
;prompt and allows entry of customer information, otherwise puts the user
;in the Check# field in the Trans table
;----------------------------------------------------------------
 If Not Isblank([])
 Then Moveto [trans->]
 Newtable()
 MoveTo [Check#]
 Arrivefield()
 Else
 TkMessage = "This is a New Customer"
 Prompt "Entering New Customer Information", "Press F10 for Options" 
 Endproc

Proc PopAcct()
;----------------------------------------------------------------
;Field Arrival procedure for Accnt_Type Field in Cust Table
;Pops up the two possible values
;----------------------------------------------------------------
 Popup(16,20,1,2)
 [] = retval
EndProc

Proc GetSpous()
;----------------------------------------------------------------
;Field Good Depart Procedure for Spouse Field in Cust Table
;Forces user entry for a joint account, displaying message
;----------------------------------------------------------------
 If [Acct_Type] = "Joint"
   Then If IsBlank([])
          Then TkMessage = "Spouse must be Entered for Joint Account"
          TKAccept = False
        Else
          TKAccept = True
        Endif
 Endif
EndProc

Proc IsSpous()
;----------------------------------------------------------------
;Field Arrival Procedure for Spouse Field in Cust Table
;Skips the Spouse field for Individual accounts easing data entry
;----------------------------------------------------------------
 If [Acct_Type] = "Individual"
   Then CtrlBackspace    ;allows dynamic activity
    If TKChar = TKLeft
      Then left
    Else Right
      Newfield()
    Endif
 Endif
Endproc

Proc Lvnow()
;----------------------------------------------------------------
;Field Good Depart Procedure for Balance Field in Cust Table
; Puts the user in the Check# field in Trans Table
; Smooths the data entry process;User need not save it using menu
;----------------------------------------------------------------
 Moveto [trans->]
 Arrivetable()
 MoveTo [Check#]
 Arrivefield()
EndProc
